"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.taskRouter = void 0;
const express_1 = require("express");
const task_record_1 = require("../records/task.record");
exports.taskRouter = (0, express_1.Router)()
    .get('/', (req, res) => __awaiter(void 0, void 0, void 0, function* () {
    const tasks = yield task_record_1.TaskRecord.listAll();
    res.json(tasks);
}))
    .get('/next-year/', (req, res) => __awaiter(void 0, void 0, void 0, function* () {
    const nextYearTasks = yield task_record_1.TaskRecord.nextYear();
    res.json(nextYearTasks);
}))
    .get('/:id', (req, res) => __awaiter(void 0, void 0, void 0, function* () {
    const taskId = yield task_record_1.TaskRecord.getOne(req.params.id);
    res.json(taskId);
}))
    .patch('/:id', (req, res) => __awaiter(void 0, void 0, void 0, function* () {
    const updateTask = yield task_record_1.TaskRecord.getOne(req.params.id);
    const data = Object.assign(Object.assign({ id: req.params.id }, req.body), { taskTodo: req.body.taskTodo });
    const newTask = new task_record_1.TaskRecord(data);
    yield newTask.update();
    res.json(updateTask);
}))
    .delete('/:id/', (req, res) => __awaiter(void 0, void 0, void 0, function* () {
    const taskDelete = yield task_record_1.TaskRecord.delete(req.params.id);
    res.json(taskDelete);
}))
    .post('/add/', (req, res) => __awaiter(void 0, void 0, void 0, function* () {
    const addTask = new task_record_1.TaskRecord(req.body);
    yield addTask.insert();
    res.json(addTask);
}));
//# sourceMappingURL=task.router.js.map